package com.inca.npbusi.sales.bms_trasin;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.extension.ui.FileExplorer;
import com.inca.np.extension.ui.FileExplorer.FileMode;
import com.inca.np.extension.util.DirHelper;
import com.inca.np.gui.control.CFormlayout;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.util.DecimalHelper;
import com.inca.npx.ste.Apinfo;
import com.inca.npx.ste.CSteModelAp;
import com.inca.pubsrv.NpbusiDBHelper;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.io.File;
import java.util.HashMap;
import java.util.Vector;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class bms_tracksing_ste extends CSteModelAp {
   JTextField a;

   public bms_tracksing_ste(CFrame var1) {
      super(var1, "植入介入跟踪单");
   }

   public String getTablename() {
      return "bms_track_single_v";
   }

   public String getSaveCommandString() {
      return "com.inca.npbusi.sales.bms_trasin.bms_tracksing_ste.植入介入跟踪单";
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector var1;
      (var1 = new Vector()).add(new Apinfo("上传", "0"));
      var1.add(new Apinfo("预览附件", "1"));
      var1.add(new Apinfo("打印附件", "0"));
      var1.add(new Apinfo("下载附件", "0"));
      var1.add(new Apinfo("删除附件", "0"));
      return var1;
   }

   protected int on_actionPerformed(String var1) {
      if (!"勾兑销售发货单".equals(var1)) {
         if (var1.equals("上传")) {
            if (!"1".equals(this.getApvalue("上传"))) {
               this.infoMessage("提示信息", "您没有【上传】的权限，请联系管理员！");
               return -1;
            }

            this.a();
         } else if (var1.equals("预览附件")) {
            if (!"1".equals(this.getApvalue("预览附件"))) {
               this.infoMessage("提示信息", "您没有【预览附件】的权限，请联系管理员！");
               return -1;
            }

            this.a(FileMode.PREVIEW_MODE);
         } else if (var1.equals("打印附件")) {
            if (!"1".equals(this.getApvalue("打印附件"))) {
               this.infoMessage("提示信息", "您没有【打印附件】的权限，请联系管理员！");
               return -1;
            }

            this.a(FileMode.PRINT_MODE);
         } else if (var1.equals("删除附件")) {
            if (!"1".equals(this.getApvalue("删除附件"))) {
               this.infoMessage("提示信息", "您没有【删除附件】的权限，请联系管理员！");
               return -1;
            }

            this.a(FileMode.DELETE_MODE);
         } else if ("下载附件".equals(var1)) {
            if (!"1".equals(this.getApvalue("下载附件"))) {
               this.infoMessage("提示信息", "您没有【下载附件】的权限，请联系管理员！");
               return -1;
            }

            this.a(FileMode.DOWLOAD_MODE);
         }

         return super.on_actionPerformed(var1);
      } else {
         bms_tracksing_ste var9 = this;
         String var2 = ClientUserManager.getCurrentUser().getEntryid();
         var2 = "not exists (select 1 from bms_track_single where salesdtlid = bms_track_single_hov_v.salesdtlid and   manualseq=bms_track_single_hov_v.sequencecode  ) and bms_track_single_hov_v.entryid=" + var2;
         bms_tracksing_hov var3;
         if ((var3 = new bms_tracksing_hov()).showDialog(this.frame, "由销售发货单生成", "settletypeid", "%", var2) != null) {
            CTable var10;
            DBTableModel var12 = (DBTableModel)(var10 = var3.getDlgtable()).getModel();
            int[] var11 = var10.getSelectedRows();

            for(int var4 = 0; var4 < var11.length; ++var4) {
               int var5 = var9.getDBtableModel().getRowCount();
               var9.getDBtableModel().appendRow();
               String var6 = var12.getItemValue(var11[var4], "goodsqty");
               String var7 = var12.getItemValue(var11[var4], "salesdtlid");

               try {
                  if (DecimalHelper.comparaDecimal(var6, "0") <= 0) {
                     continue;
                  }
               } catch (Exception var8) {
                  var8.printStackTrace();
                  var9.warnMessage("Error", var8.getMessage());
                  return 0;
               }

               var9.setItemValue(var5, "customname", var12.getItemValue(var11[var4], "customname"));
               var9.setItemValue(var5, "goodsqty", var12.getItemValue(var11[var4], "goodsqty"));
               var9.setItemValue(var5, "salesdtlid", var7);
               var9.setItemValue(var5, "salername", var12.getItemValue(var11[var4], "salername"));
               var9.setItemValue(var5, "inputmanname", var12.getItemValue(var11[var4], "inputmanname"));
               var9.setItemValue(var5, "lotno", var12.getItemValue(var11[var4], "lotno"));
               var9.setItemValue(var5, "goodsid", var12.getItemValue(var11[var4], "goodsid"));
               var9.setItemValue(var5, "goodsname", var12.getItemValue(var11[var4], "goodsname"));
               var9.setItemValue(var5, "goodsno", var12.getItemValue(var11[var4], "goodsno"));
               var9.setItemValue(var5, "registdocno", var12.getItemValue(var11[var4], "registdocno"));
               var9.setItemValue(var5, "factoryname", var12.getItemValue(var11[var4], "factoryname"));
               var9.setItemValue(var5, "businessdate", var12.getItemValue(var11[var4], "credate"));
               var9.setItemValue(var5, "credate", NpbusiDBHelper.getSysdate());
               var9.setItemValue(var5, "manualseq", var12.getItemValue(var11[var4], "sequencecode"));
               var9.setItemValue(var5, "salerid", var12.getItemValue(var11[var4], "salerid"));
               var9.setItemValue(var5, "inputmanid", var12.getItemValue(var11[var4], "inputmanid"));
               var9.setItemValue(var5, "lotid", var12.getItemValue(var11[var4], "lotid"));
               var9.setdbStatus(var5, 1);
            }

            var9.tableChanged();
            var9.setRow(var9.getRowCount());
         }

         return 0;
      }
   }

   private void a() {
      DBTableModel var1;
      if ((var1 = this.getDBtableModel()) != null && this.getRow() >= 0) {
         String var2 = "";
         if (this.getRow() != -1) {
            var2 = var1.getItemValue(this.getRow(), "manualseq");
         }

         JFileChooser var3 = new JFileChooser();
         File var4 = new File(DirHelper.getLastUsedDir());
         var3.setMultiSelectionEnabled(true);
         if (var4.isDirectory()) {
            var3.setCurrentDirectory(var4);
         } else {
            var3.setSelectedFile(var4);
         }

         if (var3.showOpenDialog(this.frame) == 0) {
            File[] var15 = var3.getSelectedFiles();
            int var16 = 0;
            File[] var8 = var15;
            int var7 = var15.length;
            int var6 = 0;

            while(true) {
               if (var6 >= var7) {
                  this.infoMessage("提示信息", "上传了" + var16 + "个文件，失败" + (var15.length - var16) + "个文件！");
                  break;
               }

               File var5 = var8[var6];
               String var9 = var5.getName() + var2;
               DirHelper.saveDir(var5.getAbsolutePath());
               String var10 = var1.getItemValue(this.getRow(), "filegroupid");
               if ("".equals(var10) || var10 == null) {
                  String var11 = " select np_filegroup_seq.nextVal filegroupid from dual";
                  RemotesqlHelper var12 = new RemotesqlHelper();

                  try {
                     var10 = var12.doSelect(var11, 0, 1).getItemValue(0, "filegroupid");
                     var1.setItemValue(this.getRow(), "filegroupid", var10);
                     this.doSaveSlient();
                  } catch (Exception var14) {
                     var14.printStackTrace();
                  }
               }

               if ("".equals(var10) || var10 == null) {
                  this.errorMessage("提示信息", "取不到附件目录ID");
                  return;
               }

               try {
                  if (!"".equals(var9) && var9 != null && !"该证照的命名规则没有定义".equals(var9)) {
                     String var17;
                     if ((var17 = var5.getName()).indexOf(".") != -1) {
                        var17 = var17.substring(var17.lastIndexOf("."));
                     }

                     new File(FileExplorer.TMP_DIR + File.separator + var9 + var17);
                  }

                  ++var16;
               } catch (Exception var13) {
                  var13.printStackTrace();
               }

               ++var6;
            }
         }

      } else {
         this.infoMessage("提示信息", "请选择要上传的跟踪单！");
      }
   }

   private void a(FileExplorer.FileMode var1) {
      DBTableModel var2;
      if ((var2 = this.getDBtableModel()) != null && this.getRow() >= 0) {
         String var4 = var2.getItemValue(this.getRow(), "filegroupid");
         if (!"".equals(var4) && var4 != null) {
            FileExplorer var5 = new FileExplorer(var4, var1);
            HashMap var3;
            (var3 = new HashMap()).put("预览", this.getApvalue("预览附件"));
            var3.put("打印", this.getApvalue("打印附件"));
            var3.put("下载", this.getApvalue("下载附件"));
            var3.put("删除", this.getApvalue("删除附件"));
            var5.setApinfo(var3);
            if (var5.getFileCount() == 1) {
               if (var1 == FileMode.DELETE_MODE) {
                  var5.deleteFile();
               } else if (var1 == FileMode.PREVIEW_MODE) {
                  var5.previewFile();
               } else if (var1 == FileMode.PRINT_MODE) {
                  var5.printFile();
               } else if (var1 == FileMode.DOWLOAD_MODE) {
                  var5.downloadFile();
               }
            } else if (var5.getFileCount() > 1) {
               var5.setModal(true);
               var5.setLocationRelativeTo((Component)null);
               var5.setVisible(true);
            } else {
               JOptionPane.showMessageDialog(this.frame, "没有附件！");
            }
         } else {
            JOptionPane.showMessageDialog(this.frame, "没有附件！");
         }
      } else {
         this.infoMessage("提示信息", "请选择证照类型！");
      }
   }

   protected JPanel createSecondtoolbar() {
      JPanel var1;
      (var1 = new JPanel()).setLayout(new CFormlayout(1, 1));
      JLabel var2;
      (var2 = new JLabel("<html><span style='font:'宋体' bold 12px;line-height:25px'>请输入序列号：</span></html>")).setPreferredSize(new Dimension(100, 30));
      this.a = new JTextField();
      this.a.setPreferredSize(new Dimension(200, 30));
      this.a.setFont(new Font("宋体", 0, 20));
      this.a.setFocusable(true);
      this.a.addKeyListener(new KeyAdapter() {
         public final void keyPressed(KeyEvent var1) {
            String var5;
            if (var1.getKeyCode() == 10 && (var5 = bms_tracksing_ste.this.a.getText()) != null && !"".equals(var5.trim())) {
               try {
                  int var2 = bms_tracksing_ste.this.getRowCount();
                  String var3 = ClientUserManager.getCurrentUser().getEntryid();
                  DBTableModel var6;
                  if ((var6 = bms_tracksing_ste.a(bms_tracksing_ste.this, var5, var3)) != null && var6.getRowCount() > 0) {
                     bms_tracksing_ste.this.getDBtableModel().bindMemds(var6);
                     bms_tracksing_ste.this.tableChanged();
                     bms_tracksing_ste.this.a.selectAll();
                     bms_tracksing_ste.this.getTable().setRowSelectionInterval(var2, bms_tracksing_ste.this.getRowCount() - 1);
                     bms_tracksing_ste.this.setRow(bms_tracksing_ste.this.getRowCount() - 1);
                     return;
                  }

                  bms_tracksing_ste.this.a.selectAll();
                  return;
               } catch (Exception var4) {
                  var4.printStackTrace();
                  bms_tracksing_ste.this.warnMessage("Error", var4.getMessage());
               }
            }

         }
      });
      var1.add(var2);
      var1.add(this.a);
      var1.addFocusListener(new FocusListener() {
         public final void focusLost(FocusEvent var1) {
         }

         public final void focusGained(FocusEvent var1) {
            bms_tracksing_ste.this.a.requestFocusInWindow();
         }
      });
      return var1;
   }

   protected int on_new(int var1) {
      this.setItemValue(var1, "credate", NpbusiDBHelper.getSysdate());
      this.setItemValue(var1, "businessdate", NpbusiDBHelper.getSysdate());
      return super.on_new(var1);
   }

   // $FF: synthetic method
   static DBTableModel a(bms_tracksing_ste var0, String var1, String var2) {
      String var3 = String.format("select salesdtlid,  customname,  salername,  salerid,  inputmanname,  inputmanid,  goodsid,  goodsname,  lotid,  lotno,  registdocno,  factoryid,  factoryname,  '1' goodsqty,  credate businessdate,  sequencecode manualseq  from bms_track_single_hov_v  where bms_track_single_hov_v.sequencecode='%s'  and not exists (select 1 from bms_track_single where salesdtlid = bms_track_single_hov_v.salesdtlid and  manualseq=bms_track_single_hov_v.sequencecode )  and bms_track_single_hov_v.entryid=%s ", var1.trim(), var2);
      DBTableModel var4 = (new RemotesqlHelper()).doSelect(var3, 0, 2147483646);

      for(int var5 = 0; var5 < var4.getRowCount(); ++var5) {
         var4.setdbStatus(var5, 1);
      }

      return var4;
   }
}
